unit UfloppyRead1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Md5DeftEdit, ComCtrls;

type
  TForm1 = class(TForm)
    DeftEdit1: TDeftEdit;
    Label1: TLabel;
    Button1: TButton;
    Memo1: TMemo;
    UpDown1: TUpDown;
    Label4: TLabel;
    Button2: TButton;
    Label5: TLabel;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    DeftEdit2: TDeftEdit;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Button3Click(Sender: TObject);
    procedure DeftEdit2Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Type
  TSectorData = packed array[0..127] of byte;
  TInfile = file of TSectorData;
  TOutfile= file of TSectorData;
var
  SectorTable : array[1..26] of integer;
  Infile      : TInfile;
  Outfile     : TOutfile;
  track       : 0..76;
  sector      : 1..26;
  mySector    : TSectorData;


Procedure initSectorTable21;
Begin
  {2:1}
  sectortable[ 1] := 1;
  sectortable[ 2] := 3;
  sectortable[ 3] := 5;
  sectortable[ 4] := 7;
  sectortable[ 5] := 9;
  sectortable[ 6] :=11;
  sectortable[ 7] :=13;
  sectortable[ 8] :=15;
  sectortable[ 9] :=17;
  sectortable[10] :=19;
  sectortable[11] :=21;
  sectortable[12] :=23;
  sectortable[13] :=25;
  sectortable[14] := 2;
  sectortable[15] := 4;
  sectortable[16] := 6;
  sectortable[17] := 8;
  sectortable[18] :=10;
  sectortable[19] :=12;
  sectortable[20] :=14;
  sectortable[21] :=16;
  sectortable[22] :=18;
  sectortable[23] :=20;
  sectortable[24] :=22;
  sectortable[25] :=24;
  sectortable[26] :=26;
end;


Function SectorTranslate(t,s:integer):integer;
//apply 2:1 sector interleave
//then add skew offset of 6 based on track #
var
  SkewOffset:integer;
Begin
  s:=SectorTable[s];
  SkewOffset := ((t-1) mod 13) * 6;
  SkewOffset := SkewOffset mod 26;
  s:=s+SkewOffset;
  While s > 26 do begin
    s:=s-26;
    MessageBeep(-1);
    end;
  SectorTranslate := s;
end;


Procedure ReadSector(T,S:integer);
var rec : Integer;
Begin
  rec := T *26 + s;
  Form1.Label4.Caption := 'T = '+IntToStr(t)+' s='+IntToStr(s)+' rec= '+IntToStr(rec);
  Seek(InFile,rec);
  Read(Infile,mySector);
end;

Procedure WriteSector(T,S:integer);
var rec : Integer;
Begin
  rec := T *26 + s;
  Seek(outFile,rec);
  Write(Outfile,mySector);
end;

procedure TForm1.Button1Click(Sender: TObject);
var t,s:integer;
begin
  Button2.Enabled := false;
  UpDown1.Enabled := false;

  initsectortable21;
  AssignFile(infile,DeftEdit1.text{'c:\iisource\u1301bas.vol'});
  reset(infile);
  AssignFile(outfile,'c:\psystem\temp.vol'); {iisource\outfile.vol');}
  rewrite(outfile);

  for t := 1 to 76 do begin
    for s := 1 to 26 do begin
      readSector(t,Sectortranslate(t,s)-1);
      WriteSector(t-1,S-1)
      end;
    end;
  closeFile(outfile);
  closeFile(infile);
  //Now reset globals
  track:=1;   //Ignore track 0
  Sector := 1;
  ShowMessage('Disc IMAGE converted, saved in '+DeftEdit2.text);
  Button2.Enabled := true;


end;


Procedure DisplaySector;
var s:string; offset,i:integer; m:byte;
Begin
//  Form1.Memo1.Clear;
  Form1.Memo1.Lines.add('T='+IntToStr(track)+' S='+IntToStr(Sector)+ ' Raw='+IntToStr(Sectortranslate(track,sector)));
  for offset := 0 to 1 do begin
    s:='';
    //some calculations to show 1 lines of text per 128 byte sectors
    for i:= 1 to 64 do begin
      m:= mySector[offset*64 +i -1];
      If m > 127 then m := m - 128;
      If (m> 31) and (m<127) then
        s:=s+chr(m)
        Else s:=s+' ';
      end;
      Form1.Memo1.Lines.Add(s);
    end;  //offset
end;

var infileopened : boolean;    //Remember to close the file on the way out
procedure TForm1.Button2Click(Sender: TObject);
begin
  AssignFile(infile,DeftEdit1.text{'c:\iisource\u1301bas.vol'});
  reset(infile);
  InFileOpened := true;
  readSector(track,Sectortranslate(track,Sector)-1);
  DisplaySector;
  UpDown1.Enabled := true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If infileOpened then CloseFile(Infile);
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  if button = btPrev then begin  //Prev sectors
    if sector = 1 then begin
      sector:= 26; dec(track);
      end
    else Sector := sector-1;
    end
  else begin                     //Next sectors
    if sector=26 then begin
      Sector:=1; inc(Track);
      end
    else Sector:=Sector+1;
    end;
  Label5.Caption := 'TRACK = '+IntToStr(Track)+' SECTOR = '+IntToStr(Sector);
  readSector(track,Sectortranslate(track,sector)-1);
  DisplaySector;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  If OpenDialog1.execute then begin
    DeftEdit1.Text := OpenDialog1.FileName
    end;
end;

procedure TForm1.DeftEdit2Exit(Sender: TObject);
begin
  if DeftEdit2.Text = DeftEdit1.text then begin
    ShowMessage('The destination is the same as the source file');
    DeftEdit2.text:='';
    DeftEdit2.SetFocus;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 infileOpened := false;
end;

end.
